#!/usr/bin/env python3


# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!          NE PAS MODIFIER CE FICHIER            !!!
# !!!                                                !!!
# !!!          Vous devez effectuer votre            !!!
# !!!        travail dans client-tutoriel.py         !!!
# !!!         ou dans d'autres fichiers que          !!!
# !!!          vous aurez vous-même créé.            !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!                                                !!!
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


from lib.Network import *

# Affiche les échanges avec le serveur (false pour désactiver)
debug_mode (True)

print ("""Bienvenue dans cette introduction à AppoLab !

AppoLab est un serveur d'exercices algorithmiques que vous allez devoir 
utiliser pour vos APPs. Je vais vous guider pas à pas pour que vous 
puissiez vous débrouiller tout·e seul·e.""")

attendre()

print ("""
Le client va maintenant tenter de se connecter automatiquement au serveur 
AppoLab. Il vous faut bien entendu pour cela une connection internet.
(En cas de problème, appellez un enseignant.)""")
attendre()

connexion ("im2ag-appolab.u-ga.fr")

print ("""
Si tout va bien, vous devez avoir reçu le message de bienvenue d'AppoLab. Si 
non, arrêtez ce programme (avec Ctrl-C) et demandez de l'aide à un·e 
enseignant·e.""")

attendre()

print ("""
Comme indiqué, commencez par vous loguer avec l'identifiant et le mot de
passe qui vous ont été fournis. Pour les étudiants d'INF301, le login est
votre numéro d'étudiant·e, et le mot de passe votre nom en majuscule.
Entrez les au clavier ainsi :
login 12345678 \"MOT DE PASSE\" """)

while True:
    login = lire_clavier()
    reponse = envoyerRecevoir(login)

    if "Veuillez d'abord" in reponse:
        print ("Vous devez utiliser la commande 'login'")

    elif "incorrect" in reponse:
        print ("Vu avez du vous tromper dans vos identifiants, réessayez...")

    elif "Bienvenue" in reponse:
        break

    else:
        print ("Message inconnu, réessayez de vous loguer...")

print ("""
Bravo, vous venez de vous identifier auprès du serveur !
Comme vous pouvez le voir ce programme trace tout ce que vous envoyez au 
serveur sur les lignes commençant par <<<envoi<<<, et tout ce que répond le 
serveur sur des lignes commençant par >>>recu >>>.""")

attendre()

print ("""
Vous êtes maintenant prêt·e à lancer le premier exercice qui se nomme 'tutoriel'.
Lancez le grâce à la commande 'load' ainsi :
load tutoriel""")

while True:
    load = lire_clavier()
    reponse = envoyerRecevoir(load)

    if "Commande inconnue" in reponse:
        print ("Vous devez utiliser la commande 'load'")

    elif "n'existe pas" in reponse:
        print ("Vu avez du vous tromper dans le nom de l'exercice, réessayez...")

    elif "Bienvenue" in reponse:
        break

    else:
        print ("Message inconnu, réessayez de vous loguer...")


print ("""
Voilà, vous venez de lancer votre premier exercice...
Suivez les consignes de l'exercice maintenant.""")

while True:
    message = lire_clavier()
    reponse = envoyerRecevoir(message)

    if "trop lent" in reponse:
        break


attendre()

if "beaucoup trop lent" in reponse:
    print ("""
    Bon, finalement vous avez échoué à cet exercice, mais c'était
    fait exprès :-)""")

    attendre()
    print ("""
    Relancez ce programme et essayez d'être plus rapide cette fois !
    """)

else:
    print ( """
Bravo vous êtes plutôt rapide.
Vous pourriez relancer ce programme pour tenter à nouveau votre
chance, mais vous allez vite vous rendre compte que c'est fastidieux
de retaper votre login et mot de passe à chaque fois...""")

    attendre()
    print ("""
Changez donc de programme et utilisez à la place 'client-tutoriel.py'
Par contre, vous devez tout d'abord éditer le fichier, et y trouver où 
rentrer votre identifiant et mot de passe.""")

    attendre()
    print ("Au revoir.")

deconnexion()
print ("Fin de la connection au serveur")
